/*
Code automatically generated by asn1scc tool
*/
#include <limits.h>
#include <string.h>
#include <math.h>
#include "Camera.h"

#if !defined(_MSC_VER) || _MSC_VER >= 1800
void FlashStrength_Initialize(FlashStrength* pVal)
{
    *pVal = (FlashStrength) 0;
}
#endif

 
flag FlashStrength_IsConstraintValid(const FlashStrength* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = T_UInt8_IsConstraintValid(pVal, pErrCode);

	return ret;
}

flag FlashStrength_Encode(const FlashStrength* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? FlashStrength_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    ret = T_UInt8_Encode(pVal, pBitStrm, pErrCode, FALSE);
    }

	return ret;
}

flag FlashStrength_Decode(FlashStrength* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	ret = T_UInt8_Decode(pVal, pBitStrm, pErrCode);

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void ShutterTime_Initialize(ShutterTime* pVal)
{
    *pVal = (ShutterTime) 0;
}
#endif

 
flag ShutterTime_IsConstraintValid(const ShutterTime* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = T_UInt32_IsConstraintValid(pVal, pErrCode);

	return ret;
}

flag ShutterTime_Encode(const ShutterTime* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? ShutterTime_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    ret = T_UInt32_Encode(pVal, pBitStrm, pErrCode, FALSE);
    }

	return ret;
}

flag ShutterTime_Decode(ShutterTime* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	ret = T_UInt32_Decode(pVal, pBitStrm, pErrCode);

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void CameraFlash_Initialize(CameraFlash* pVal)
{
    *pVal = (CameraFlash) {
    .enable = FALSE,
    .strength = 0
};
}
#endif

 
flag CameraFlash_IsConstraintValid(const CameraFlash* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = T_Boolean_IsConstraintValid(&pVal->enable, pErrCode);
	if (ret) {
	    ret = FlashStrength_IsConstraintValid(&pVal->strength, pErrCode);
	
	}

	return ret;
}

flag CameraFlash_Encode(const CameraFlash* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? CameraFlash_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    /*Encode enable */
	    ret = T_Boolean_Encode(&pVal->enable, pBitStrm, pErrCode, FALSE);
	    if (ret) {
	        /*Encode strength */
	        ret = FlashStrength_Encode(&pVal->strength, pBitStrm, pErrCode, FALSE);
	    
	    }
    }

	return ret;
}

flag CameraFlash_Decode(CameraFlash* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	/*Decode enable */
	ret = T_Boolean_Decode(&pVal->enable, pBitStrm, pErrCode);
	if (ret) {
	    /*Decode strength */
	    ret = FlashStrength_Decode(&pVal->strength, pBitStrm, pErrCode);
	
	}


	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void CameraRegion_Initialize(CameraRegion* pVal)
{
    *pVal = (CameraRegion) {
    .enable = FALSE,
    .region = {
        .offset_x = 0,
        .offset_y = 0,
        .size_x = 0,
        .size_y = 0
    }
};
}
#endif

 
flag CameraRegion_IsConstraintValid(const CameraRegion* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = T_Boolean_IsConstraintValid(&pVal->enable, pErrCode);
	if (ret) {
	    ret = PlanarRegion_IsConstraintValid(&pVal->region, pErrCode);
	
	}

	return ret;
}

flag CameraRegion_Encode(const CameraRegion* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? CameraRegion_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    /*Encode enable */
	    ret = T_Boolean_Encode(&pVal->enable, pBitStrm, pErrCode, FALSE);
	    if (ret) {
	        /*Encode region */
	        ret = PlanarRegion_Encode(&pVal->region, pBitStrm, pErrCode, FALSE);
	    
	    }
    }

	return ret;
}

flag CameraRegion_Decode(CameraRegion* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	/*Decode enable */
	ret = T_Boolean_Decode(&pVal->enable, pBitStrm, pErrCode);
	if (ret) {
	    /*Decode region */
	    ret = PlanarRegion_Decode(&pVal->region, pBitStrm, pErrCode);
	
	}


	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void SensorGain_Initialize(SensorGain* pVal)
{
    *pVal = (SensorGain) 0.00000000000000000000E+000;
}
#endif

 
flag SensorGain_IsConstraintValid(const SensorGain* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = T_Float_IsConstraintValid(pVal, pErrCode);

	return ret;
}

flag SensorGain_Encode(const SensorGain* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? SensorGain_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    ret = T_Float_Encode(pVal, pBitStrm, pErrCode, FALSE);
    }

	return ret;
}

flag SensorGain_Decode(SensorGain* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	ret = T_Float_Decode(pVal, pBitStrm, pErrCode);

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void CameraExposure_Initialize(CameraExposure* pVal)
{
    *pVal = (CameraExposure) {
    .shutter = 0,
    .gain = 0.00000000000000000000E+000
};
}
#endif

 
flag CameraExposure_IsConstraintValid(const CameraExposure* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = ShutterTime_IsConstraintValid(&pVal->shutter, pErrCode);
	if (ret) {
	    ret = SensorGain_IsConstraintValid(&pVal->gain, pErrCode);
	
	}

	return ret;
}

flag CameraExposure_Encode(const CameraExposure* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? CameraExposure_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    /*Encode shutter */
	    ret = ShutterTime_Encode(&pVal->shutter, pBitStrm, pErrCode, FALSE);
	    if (ret) {
	        /*Encode gain */
	        ret = SensorGain_Encode(&pVal->gain, pBitStrm, pErrCode, FALSE);
	    
	    }
    }

	return ret;
}

flag CameraExposure_Decode(CameraExposure* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	/*Decode shutter */
	ret = ShutterTime_Decode(&pVal->shutter, pBitStrm, pErrCode);
	if (ret) {
	    /*Decode gain */
	    ret = SensorGain_Decode(&pVal->gain, pBitStrm, pErrCode);
	
	}


	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void CameraAutoExposure_Initialize(CameraAutoExposure* pVal)
{
    *pVal = (CameraAutoExposure) {
    .enable = FALSE,
    .max_shutter = 0,
    .max_gain = 0.00000000000000000000E+000
};
}
#endif

 
flag CameraAutoExposure_IsConstraintValid(const CameraAutoExposure* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = T_Boolean_IsConstraintValid(&pVal->enable, pErrCode);
	if (ret) {
	    ret = ShutterTime_IsConstraintValid(&pVal->max_shutter, pErrCode);
	    if (ret) {
	        ret = SensorGain_IsConstraintValid(&pVal->max_gain, pErrCode);
	    
	    }
	}

	return ret;
}

flag CameraAutoExposure_Encode(const CameraAutoExposure* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? CameraAutoExposure_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    /*Encode enable */
	    ret = T_Boolean_Encode(&pVal->enable, pBitStrm, pErrCode, FALSE);
	    if (ret) {
	        /*Encode max_shutter */
	        ret = ShutterTime_Encode(&pVal->max_shutter, pBitStrm, pErrCode, FALSE);
	        if (ret) {
	            /*Encode max_gain */
	            ret = SensorGain_Encode(&pVal->max_gain, pBitStrm, pErrCode, FALSE);
	        
	        }
	    }
    }

	return ret;
}

flag CameraAutoExposure_Decode(CameraAutoExposure* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	/*Decode enable */
	ret = T_Boolean_Decode(&pVal->enable, pBitStrm, pErrCode);
	if (ret) {
	    /*Decode max_shutter */
	    ret = ShutterTime_Decode(&pVal->max_shutter, pBitStrm, pErrCode);
	    if (ret) {
	        /*Decode max_gain */
	        ret = SensorGain_Decode(&pVal->max_gain, pBitStrm, pErrCode);
	    
	    }
	}


	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void PatternSequence_Initialize(PatternSequence* pVal)
{
    *pVal = (PatternSequence) 0;
}
#endif

 
flag PatternSequence_IsConstraintValid(const PatternSequence* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = T_UInt16_IsConstraintValid(pVal, pErrCode);

	return ret;
}

flag PatternSequence_Encode(const PatternSequence* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? PatternSequence_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    ret = T_UInt16_Encode(pVal, pBitStrm, pErrCode, FALSE);
    }

	return ret;
}

flag PatternSequence_Decode(PatternSequence* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	ret = T_UInt16_Decode(pVal, pBitStrm, pErrCode);

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void CameraPattern_Initialize(CameraPattern* pVal)
{
    *pVal = (CameraPattern) {
    .enable = FALSE,
    .sequence = 0
};
}
#endif

 
flag CameraPattern_IsConstraintValid(const CameraPattern* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = T_Boolean_IsConstraintValid(&pVal->enable, pErrCode);
	if (ret) {
	    ret = PatternSequence_IsConstraintValid(&pVal->sequence, pErrCode);
	
	}

	return ret;
}

flag CameraPattern_Encode(const CameraPattern* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? CameraPattern_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    /*Encode enable */
	    ret = T_Boolean_Encode(&pVal->enable, pBitStrm, pErrCode, FALSE);
	    if (ret) {
	        /*Encode sequence */
	        ret = PatternSequence_Encode(&pVal->sequence, pBitStrm, pErrCode, FALSE);
	    
	    }
    }

	return ret;
}

flag CameraPattern_Decode(CameraPattern* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	/*Decode enable */
	ret = T_Boolean_Decode(&pVal->enable, pBitStrm, pErrCode);
	if (ret) {
	    /*Decode sequence */
	    ret = PatternSequence_Decode(&pVal->sequence, pBitStrm, pErrCode);
	
	}


	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void CameraConfiguration_Initialize(CameraConfiguration* pVal)
{
    *pVal = (CameraConfiguration) {
    .shutter = 0,
    .gain = 0.00000000000000000000E+000,
    .auto_exposure_enabled = FALSE,
    .max_shutter = 0,
    .max_gain = 0.00000000000000000000E+000,
    .region_enabled = FALSE,
    .region = {
        .offset_x = 0,
        .offset_y = 0,
        .size_x = 0,
        .size_y = 0
    },
    .flash_enabled = FALSE,
    .flash_strength = 0,
    .pattern_enabled = FALSE,
    .pattern_sequence = 0
};
}
#endif

 
flag CameraConfiguration_IsConstraintValid(const CameraConfiguration* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = ShutterTime_IsConstraintValid(&pVal->shutter, pErrCode);
	if (ret) {
	    ret = SensorGain_IsConstraintValid(&pVal->gain, pErrCode);
	    if (ret) {
	        ret = T_Boolean_IsConstraintValid(&pVal->auto_exposure_enabled, pErrCode);
	        if (ret) {
	            ret = ShutterTime_IsConstraintValid(&pVal->max_shutter, pErrCode);
	            if (ret) {
	                ret = SensorGain_IsConstraintValid(&pVal->max_gain, pErrCode);
	                if (ret) {
	                    ret = T_Boolean_IsConstraintValid(&pVal->region_enabled, pErrCode);
	                    if (ret) {
	                        ret = PlanarRegion_IsConstraintValid(&pVal->region, pErrCode);
	                        if (ret) {
	                            ret = T_Boolean_IsConstraintValid(&pVal->flash_enabled, pErrCode);
	                            if (ret) {
	                                ret = FlashStrength_IsConstraintValid(&pVal->flash_strength, pErrCode);
	                                if (ret) {
	                                    ret = T_Boolean_IsConstraintValid(&pVal->pattern_enabled, pErrCode);
	                                    if (ret) {
	                                        ret = PatternSequence_IsConstraintValid(&pVal->pattern_sequence, pErrCode);
	                                    
	                                    }
	                                }
	                            }
	                        }
	                    }
	                }
	            }
	        }
	    }
	}

	return ret;
}

flag CameraConfiguration_Encode(const CameraConfiguration* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? CameraConfiguration_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    /*Encode shutter */
	    ret = ShutterTime_Encode(&pVal->shutter, pBitStrm, pErrCode, FALSE);
	    if (ret) {
	        /*Encode gain */
	        ret = SensorGain_Encode(&pVal->gain, pBitStrm, pErrCode, FALSE);
	        if (ret) {
	            /*Encode auto_exposure_enabled */
	            ret = T_Boolean_Encode(&pVal->auto_exposure_enabled, pBitStrm, pErrCode, FALSE);
	            if (ret) {
	                /*Encode max_shutter */
	                ret = ShutterTime_Encode(&pVal->max_shutter, pBitStrm, pErrCode, FALSE);
	                if (ret) {
	                    /*Encode max_gain */
	                    ret = SensorGain_Encode(&pVal->max_gain, pBitStrm, pErrCode, FALSE);
	                    if (ret) {
	                        /*Encode region_enabled */
	                        ret = T_Boolean_Encode(&pVal->region_enabled, pBitStrm, pErrCode, FALSE);
	                        if (ret) {
	                            /*Encode region */
	                            ret = PlanarRegion_Encode(&pVal->region, pBitStrm, pErrCode, FALSE);
	                            if (ret) {
	                                /*Encode flash_enabled */
	                                ret = T_Boolean_Encode(&pVal->flash_enabled, pBitStrm, pErrCode, FALSE);
	                                if (ret) {
	                                    /*Encode flash_strength */
	                                    ret = FlashStrength_Encode(&pVal->flash_strength, pBitStrm, pErrCode, FALSE);
	                                    if (ret) {
	                                        /*Encode pattern_enabled */
	                                        ret = T_Boolean_Encode(&pVal->pattern_enabled, pBitStrm, pErrCode, FALSE);
	                                        if (ret) {
	                                            /*Encode pattern_sequence */
	                                            ret = PatternSequence_Encode(&pVal->pattern_sequence, pBitStrm, pErrCode, FALSE);
	                                        
	                                        }
	                                    }
	                                }
	                            }
	                        }
	                    }
	                }
	            }
	        }
	    }
    }

	return ret;
}

flag CameraConfiguration_Decode(CameraConfiguration* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	/*Decode shutter */
	ret = ShutterTime_Decode(&pVal->shutter, pBitStrm, pErrCode);
	if (ret) {
	    /*Decode gain */
	    ret = SensorGain_Decode(&pVal->gain, pBitStrm, pErrCode);
	    if (ret) {
	        /*Decode auto_exposure_enabled */
	        ret = T_Boolean_Decode(&pVal->auto_exposure_enabled, pBitStrm, pErrCode);
	        if (ret) {
	            /*Decode max_shutter */
	            ret = ShutterTime_Decode(&pVal->max_shutter, pBitStrm, pErrCode);
	            if (ret) {
	                /*Decode max_gain */
	                ret = SensorGain_Decode(&pVal->max_gain, pBitStrm, pErrCode);
	                if (ret) {
	                    /*Decode region_enabled */
	                    ret = T_Boolean_Decode(&pVal->region_enabled, pBitStrm, pErrCode);
	                    if (ret) {
	                        /*Decode region */
	                        ret = PlanarRegion_Decode(&pVal->region, pBitStrm, pErrCode);
	                        if (ret) {
	                            /*Decode flash_enabled */
	                            ret = T_Boolean_Decode(&pVal->flash_enabled, pBitStrm, pErrCode);
	                            if (ret) {
	                                /*Decode flash_strength */
	                                ret = FlashStrength_Decode(&pVal->flash_strength, pBitStrm, pErrCode);
	                                if (ret) {
	                                    /*Decode pattern_enabled */
	                                    ret = T_Boolean_Decode(&pVal->pattern_enabled, pBitStrm, pErrCode);
	                                    if (ret) {
	                                        /*Decode pattern_sequence */
	                                        ret = PatternSequence_Decode(&pVal->pattern_sequence, pBitStrm, pErrCode);
	                                    
	                                    }
	                                }
	                            }
	                        }
	                    }
	                }
	            }
	        }
	    }
	}


	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void PatternID_Initialize(PatternID* pVal)
{
    *pVal = (PatternID) 0;
}
#endif

 
flag PatternID_IsConstraintValid(const PatternID* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = T_UInt16_IsConstraintValid(pVal, pErrCode);

	return ret;
}

flag PatternID_Encode(const PatternID* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? PatternID_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    ret = T_UInt16_Encode(pVal, pBitStrm, pErrCode, FALSE);
    }

	return ret;
}

flag PatternID_Decode(PatternID* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	ret = T_UInt16_Decode(pVal, pBitStrm, pErrCode);

	return ret;
}

